#include <iostream>
using namespace std;
#include "Test.h"
#include "meinMinElement.h"


#   pragma warning( disable : 4244 )  
//  "=": Konvertierung von "double" in "int", mglicher Datenverlust

bool meinMinElementTest()
{
   int arr[20];
   double arrd[20];
   for (int i = 0; i < 20; ++i) {
      arr[i] = i * i;
      arrd[i] = i;
   }

   bool b_res = true;
   b_res = 16 == *MeinMinElement(&arr[4], &arr[20]) && b_res;
   arr[14] = -4.3;
   b_res = -4 == *MeinMinElement(&arr[0], &arr[20]) && b_res;

   b_res = 5 == *MeinMinElement(&arrd[5], &arrd[20]) && b_res;
   arrd[13] = -16.4;
   b_res = -16.4 == *MeinMinElement(&arrd[0], &arrd[20]) && b_res;

   return b_res;
}


bool meinMinUngleichTest()
{
   int arr[20];
   double arrd[20];
   for (int i = 0; i < 20; ++i) {
      arr[i] = i * i;
      arrd[i] = i;
   }
   bool b_res = true;
   // Suche minimale Element ungleich 16
   b_res = 25 ==  *MeinMinElementUngleich(&arr[4], &arr[20], 16);
   arr[14] = -4.3;
   b_res = b_res &&  -4 ==  *MeinMinElementUngleich(&arr[0], &arr[20], 16) ;
   b_res = b_res && 5 ==  *MeinMinElementUngleich(&arrd[5], &arrd[20], 16);
   arrd[13] = -16.4;
   b_res = b_res && -16.4 == *MeinMinElementUngleich(&arrd[0], &arrd[20], 111);
   return b_res;
}

// all elements get the same value, except one, this must be the minima
bool meinMinUngleichTest2()
{

   int arr[20];
   double arrd[20];
   for (int i = 0; i < 20; ++i) {
      arr[i] = 4;
      arrd[i] = 15;
   }
   bool b_res = true;
   // Suche minimale Element ungleich 16
   b_res = 4 ==  *MeinMinElementUngleich(&arr[4], &arr[19], 16);
   cout << *MeinMinElementUngleich(&arr[4], &arr[19], 16) << " ";

   arr[19] = 40000;
   b_res = b_res && 40000 == *MeinMinElementUngleich(&arr[0], &arr[19], 4);
   cout << *MeinMinElementUngleich(&arr[0], &arr[19], 4) << "\n";

   b_res = b_res && 15 ==  *MeinMinElementUngleich(&arrd[5], &arrd[19], 16) ;
   arrd[19] = 55555;
   cout << *MeinMinElementUngleich(&arrd[5], &arrd[19], 16) << " ";
   b_res = b_res && 55555 ==  *MeinMinElementUngleich(&arrd[0], &arrd[19], 15);
   cout << *MeinMinElementUngleich(&arrd[0], &arrd[19], 15) << "\n";
   return b_res;
}


// all elements get the same value, therefore there should no minima
// or it should be this value
bool meinMinUngleichTest3()
{

   int arr[20];
   double arrd[20];
   for (int i = 0; i < 20; ++i) {
      arr[i] = 4;
      arrd[i] = 15;
   }
   bool b_res = true;
   b_res = b_res && (&arr[20] == MeinMinElementUngleich(&arr[0], &arr[20], 4));
   b_res = b_res && (&arrd[20] == MeinMinElementUngleich(&arrd[0], &arrd[20], 15));
   b_res = b_res && (4 == *MeinMinElementUngleich(&arr[0], &arr[20], 14));
   b_res = b_res && (15 == *MeinMinElementUngleich(&arrd[0], &arrd[20], 150));

   return b_res;
}



